#-------------------------------------------------------------------#
# Dice.pl							    #
#-------------------------------------------------------------------#
# Dice 4 YaBB 2.1						    #
# Version 0.3 beta						    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2006 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: September 14, 2006					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#

LoadLanguage("dice");

if ($INFO{'dsetup'} eq ""){ &fatal_error($maintxt{'1'}); }
if( $iamguest ) { &fatal_error($dicetxt{'41'}); }

my $diceset = $INFO{'dsetup'};
if( $diceset =~ /\D/ ) { &fatal_error($maintxt{'337'}); }
$scorelist = $diceset;
if ($INFO{'dback'} eq ""){ $INFO{'dback'} = "dgoto" }

if(!-e ("$vardir/$diceset.die")) {
	fopen(FILE, ">$vardir/$diceset.die", 1);
	print FILE "5\n";
	print FILE "3\n";
	print FILE "\n";
	print FILE "0\n";
	print FILE "6\n";
	print FILE "1\n";
	print FILE "1\n";
	print FILE "1\n";
	print FILE "0\n";
#	print FILE "1\n";
	fclose(FILE);
}

fopen(FILE, "$vardir/$diceset.die");
@dicesettings = <FILE>;
fclose(FILE);
chomp(@dicesettings);

(@curdicgroups) = split(/\,/, $dicesettings[2]);
$grp_num = 0;
foreach $cur (@curdicgroups) {
	$cur =~ s~[\n\r]~~g;
	chomp $cur;
	($dcgrp_allow[$grp_num], $dcgrp_view[$grp_num]) = split(/\|/, $cur);
	$grp_num++;
}


$dice_hits = $dicesettings[0];
$dice_rounds = $dicesettings[1];
$dice_lock = $dicesettings[3];
$dice_sides = $dicesettings[4];
$dice_allowstay = $dicesettings[5];
$dice_viewmode = $dicesettings[7];

$add_dice_viewmode = $dicesettings[8];
# $add_dice_rolls = $dicesettings[9];

$dice_sort = $dicesettings[6];

if($dice_sort == 1 || $dice_sort == 2) { $tb_sp = 7 } else { $tb_sp = 6 }

$theboard = $currentboard;

fopen(FILE, "$datadir/$diceset.txt");
@trdsettings = <FILE>;
fclose(FILE);
chomp(@trdsettings);

($trdname, undef) = split(/[\|]/, $trdsettings[0], 2);

$can_role = 1;
$dic_str = "";
if($dice_allowstay) { $dice_rolls = 1 }
else { $dice_rolls = $dice_rounds }

if($dice_lock) {
	$dice_gif .= qq~<img src="$modimgurl/dice/dicelock.gif" border="0" align="absmiddle" />~;
	$can_role = 0;
	$dic_str .= qq~<tr><td align="center"><span class="small">$dicetxt{'15'}</span></td></tr>~;
	$the_score = 0;
}
else { $dice_gif .= qq~<img src="$modimgurl/dice/dice.gif" border="0" align="absmiddle" />~; }

if(-e ("$vardir/$scorelist.dice")) {
	fopen(FILE, "$vardir/$scorelist.dice");
	@dicscorer = <FILE>;
	$players = @dicscorer;
	fclose(FILE);
	chomp(@dicscorer);

	for($i=0;$i<$players;$i++) {
		($dic_tot, $theuser, $thescore, $dic_val[1], $dic_val[2], $dic_val[3], $dic_val[4], $dic_val[5], $dic_val[6], $dic_val[7], $dic_val[8], $dic_val[9], $dic_val[10], $dic_hit, $dic_side, $dic_rolls, $dic_high) = split(/\|/, $dicscorer[$i]);
		if($theuser eq $username) {
			$dic_str = "";
			for($x=0;$x<$dic_rolls;$x++) {
				$the_score += $thescore;
				$can_role = 0;
				if($dic_side < 7) {
					$dic_str .= qq~<tr>~;
					for($z=1;$z<=$dic_hit;$z++) {
						if($dic_val[$z] != 0) {
							$dic_str .= qq~<td><img src="$modimgurl/dice/tern$dic_val[$z].gif" width="31" height="31" alt="" border="0" /></td>~;
						}
					}
					if(!$dice_allowstay) {
						$dic_str .= qq~<td height="31" width="31" align="center" valign="middle"><font size="2"><b>$thescore</b></font></td>~;
					}
					$dic_str .= qq~</tr>~;

				}
				else {
					$dic_str .= qq~<tr>~;
					for($z=1;$z<=$dic_hit;$z++) {
						if($dic_val[$z] != 0) {
							$dic_str .= qq~<td height="31" width="31" align="center" valign="middle" background="$modimgurl/dice/tern0.gif"><font size="2" color="#000000"><b>$dic_val[$z]</b></font></td>~;
						}
					}
					if(!$dice_allowstay) {
						$dic_str .= qq~<td height="31" width="31" align="center" valign="middle"><font size="2"><b>$thescore</b></font></td>~;
					}
					$dic_str .= qq~</tr>~;
				}
				$i++;
				$di_roll = $dic_rolls - 1;
				if($x<$di_roll) {
					($dic_tot, $theuser, $thescore, $dic_val[1], $dic_val[2], $dic_val[3], $dic_val[4], $dic_val[5], $dic_val[6], $dic_val[7], $dic_val[8], $dic_val[9], $dic_val[10], $dic_hit, $dic_side, $dic_rolls, $dic_high) = split(/\|/, $dicscorer[$i]);
				}
			}
			$i--;
		}
	}
}

sub Dicestart {

if($INFO{'round'} eq "") { $INFO{'round'} = 1 }
$this_round = $INFO{'round'};

$dice_total = 0;
$dice_str = "";
$dice_sel = "";
$dice_value = "";

if($can_role) {

for($i=1;$i<=10;$i++) {
	$dice_stay[$i] = 0;
	$dval[$i] = 0;
}

if($this_round > 1) {

my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$dicecheck{$key} = $value;
}


if($dicecheck{'dice_stay1'}) { $dice_stay[1] = 1 }
$dval[1] = $dicecheck{'diceval1'};
if($dicecheck{'dice_stay2'}) { $dice_stay[2] = 1 }
$dval[2] = $dicecheck{'diceval2'};
if($dicecheck{'dice_stay3'}) { $dice_stay[3] = 1 }
$dval[3] = $dicecheck{'diceval3'};
if($dicecheck{'dice_stay4'}) { $dice_stay[4] = 1 }
$dval[4] = $dicecheck{'diceval4'};
if($dicecheck{'dice_stay5'}) { $dice_stay[5] = 1 }
$dval[5] = $dicecheck{'diceval5'};
if($dicecheck{'dice_stay6'}) { $dice_stay[6] = 1 }
$dval[6] = $dicecheck{'diceval6'};
if($dicecheck{'dice_stay7'}) { $dice_stay[7] = 1 }
$dval[7] = $dicecheck{'diceval7'};
if($dicecheck{'dice_stay8'}) { $dice_stay[8] = 1 }
$dval[8] = $dicecheck{'diceval8'};
if($dicecheck{'dice_stay9'}) { $dice_stay[9] = 1 }
$dval[9] = $dicecheck{'diceval9'};
if($dicecheck{'dice_stay10'}) { $dice_stay[10] = 1 }
$dval[10] = $dicecheck{'diceval10'};

}

if($dice_sides < 7) {
	for($i=1;$i<=$dice_hits;$i++) {
		if($this_round > 1) {
			if($dice_stay[$i] && $dice_allowstay) {
				$dice_str .= qq~<td><img src="$modimgurl/dice/tern$dval[$i].gif" width="31" height="31" alt="" border="0" /></td>~;
				$dice_sel .= qq~<input type="hidden" name="dice_sel$i" value="checked" />~;
				$dice_value .= qq~<input type="hidden" name="dice_val$i" value="$dval[$i]" />~;
			}
			else {
				$dice_str .= qq~<td><img src="$modimgurl/dice/tern.gif" width="31" height="31" alt="" border="0" /></td>~;
				$dice_sel .= qq~<input type="hidden" name="dice_sel$i" value="" />~;
				$dice_value .= qq~<input type="hidden" name="dice_val$i" value="0" />~;
			}
		}
		else {
			$dice_str .= qq~<td><img src="$modimgurl/dice/tern.gif" width="31" height="31" alt="" border="0" /></td>~;
		}
	}
}
else {
	for($i=1;$i<=$dice_hits;$i++) {
		if($this_round > 1) {
			if($dice_stay[$i] && $dice_allowstay) {
				$dice_str .= qq~<td height="31" width="31" align="center" valign="middle" background="$modimgurl/dice/tern0.gif"><font size="2" color="#000000"><b>$dval[$i]</b></font></td>~;
				$dice_sel .= qq~<input type="hidden" name="dice_sel$i" value="checked" />~;
				$dice_value .= qq~<input type="hidden" name="dice_val$i" value="$dval[$i]" />~;
			}
			else {
				$dice_str .= qq~<td><img src="$modimgurl/dice/terna.gif" width="31" height="31" alt="" border="0" /></td>~;
				$dice_sel .= qq~<input type="hidden" name="dice_sel$i" value="" />~;
				$dice_value .= qq~<input type="hidden" name="dice_val$i" value="0" />~;
			}
		}
		else {
			$dice_str .= qq~<td><img src="$modimgurl/dice/terna.gif" width="31" height="31" alt="" border="0" /></td>~;
		}
	}
}


if($username eq "Guest") { $show_name = $maintxt{'28'}; }
else {
	if (!${$uid.$$username}{'password'}) { &LoadUser($username); }
	$show_name = ${$uid.$username}{'realname'};
}

$yymain .= qq~
<table width="400" border="0" cellspacing="1" cellpadding="2" align="center">
	<tr>
		<td align="right" valign="middle">
			<span class="small"><a href="$scripturl?num=$diceset" class="imgwindowbg"><img src="$imagesdir/board.gif" alt="" border="0" align="absmiddle" /> $dicetxt{'26'}</a></span>
		</td>
	</tr>
</table>

<table width="400" border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
		<td class="titlebg" align="left" valign="middle">
			$dice_gif<span class="text1"><b> $dicetxt{'1'}</b> - $trdname - $show_name</span>
		</td>
	</tr>
	<tr>
		<td class="catbg" align="left" valign="middle">
			$dice_sides $dicetxt{'16'} - $dicetxt{'4'} $this_round $dicetxt{'9'} $dice_rounds
		</td>
	</tr>
	<tr>
		<td align="center" class="windowbg">

		<table border="0" cellspacing="0" cellpadding="0" align="center">
			<tr>
				$dice_str
			</tr>
		</table>

		</td>
	</tr>
	<tr>
		<td class="catbg" align="left" valign="middle">

		<table border="0" cellspacing="0" cellpadding="0" align="left">
			<tr>
				<td>
					<form method="post" action="$scripturl?action=dicehit;dsetup=$diceset">
					<input type="hidden" name="button" value="0" />
					<input type="hidden" name="username" value="$username" />
					<input type="hidden" name="round" value="$this_round" />
					$dice_sel
					$dice_value
					<input type="submit" value="$dicetxt{'2'} $this_round" style="width: 100px;" />
					</form>
				</td>
~;

if($iamgmod || $iamadmin) {
$yymain .= qq~
				<td>
					<form method="post" action="$scripturl?board=$theboard;action=dicesetup;dsetup=$diceset">
					<input type="submit" value="$dicetxt{'5'}" style="width: 100px;" />
					</form>
				</td>
~;
}
$yymain .= qq~
			</tr>
		</table>

		</td>
	</tr>
</table>
~;
}
else {
if($username eq "Guest") { $show_name = $maintxt{'28'} }
else {
	if (!${$uid.$$username}{'password'}) { &LoadUser($username); }
	$show_name = ${$uid.$username}{'realname'};
}

$yymain .= qq~
<table width="400" border="0" cellspacing="1" cellpadding="2" align="center">
<tr>
<td align="right" valign="middle">
<span class="small"><a href="$scripturl?num=$diceset" class="imgwindowbg"><img src="$imagesdir/board.gif" alt="" border="0" align="absmiddle" /> $dicetxt{'26'}</a></span>
</td>
</tr>
</table>
<table width="400" border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
<tr>
<td class="titlebg" align="left" valign="middle">
$dice_gif<span class="text1"><b> $dicetxt{'1'}</b> - $trdname - $show_name</span>
</td>
</tr>
<tr>
<td align="center" class="windowbg">
<table border="0" cellspacing="0" cellpadding="0" align="center">
	$dic_str
</table>
</td>
</tr>
<tr>
<td class="catbg" align="left" valign="middle">

<table width="100%" border="0" cellspacing="0" cellpadding="0" align="left">
<tr>
~;
if($iamgmod || $iamadmin) {
$yymain .= qq~
<form method="post" action="$scripturl?board=$theboard;action=dicesetup;dsetup=$diceset">
<td>
	<input type="submit" value="$dicetxt{'5'}" style="width: 70px; font-size: 9" />
</td>
</form>
~;
}
$yymain .= qq~
<td align="right" valign="middle">
	<span class="small"><b>$dicetxt{'3'}: $the_score</b></span>
</td>
</tr>
</table>

</td>
</tr>
</table>
~;
}

if(-e ("$vardir/$scorelist.dice") && $dcgrp_allow[0] ne "") {
	fopen(FILE, "$vardir/$scorelist.dice");
	@dicescorer = <FILE>;
	$player = @dicescorer;
	fclose(FILE);
	chomp(@dicescorer);
	&PlayerSort;
	$show_grp = "";
	for($i=0;$i<$grp_num;$i++) {
		$show_grp .= qq~ - $dcgrp_view[$i]~;
	}
	$show_grp =~ s/\_/ /g;
	$yymain .= qq~
	<br /><br />
	<table border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr><td colspan="$tb_sp" class="titlebg" valign="middle">
	<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
		<tr>
		<td class="titlebg" valign="middle">
		$dice_gif<b> $dicetxt{'10'} - $trdname</b>
		</td>
		~;
		if($iamgmod || $iamadmin) {
		$yymain .= qq~
		<form method="post" action="$scripturl?action=dicereset;dsetup=$diceset">
		<td class="titlebg" align="right" valign="middle">
			<input type="submit" value="$dicetxt{'11'}" style="font-size: 9" />
		</td>
		</form>
		~;
		}
		$yymain .= qq~
		</tr>
	</table>
	</td>
	</tr>
	<tr><td colspan="$tb_sp" class="windowbg" align="left" valign="middle">
		<span class="small"><b> $dicetxt{'25'}</b>$show_grp</span>
	</td>
	</tr>
	<tr>
	~;
		if($dice_sort == 1 || $dice_sort == 2) { 
	$yymain .= qq~
		<td class="catbg" align="center" valign="middle">$dicetxt{'18'}</td>
	~;
		}
	$yymain .= qq~
		<td class="catbg" align="center" valign="middle">$dicetxt{'17'}</td>
		<td class="catbg" align="center" valign="middle">$dicetxt{'8'}</td>
		<td class="catbg" align="center" valign="middle">$dicetxt{'1'}</td>
		<td class="catbg" align="center" valign="middle">$dicetxt{'16'}</td>
		<td class="catbg" align="center" valign="middle">$dicetxt{'3'}</td>
		<td class="catbg" align="center" valign="middle">$dicetxt{'6'}</td>
	</tr>
	~;
	$z=1;
	for($i=0;$i<$player;$i++) {
		my($res_str);
		($dic_tot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicescore[$i]);
		$res_str .= qq~<table border="0" cellspacing="0" cellpadding="0" align="center">~;
			for($b=0;$b<$dic_roll;$b++) {
				$i++;
				$res_str .= qq~<tr>~;
				for($x=1;$x<=$dummy11;$x++) {
					$res_str .= qq~
					<td height="31" width="31" align="center" valign="middle" background="$modimgurl/dice/tern0.gif" /><font size="2" color="#000000"><b>$dummy[$x]</b></font></td>
					~;
				}
				if(!$dice_allowstay) {
					$res_str .= qq~<td width="31" align="center" valign="middle"><font size="2"><b>$thisscore</b></font></td>~;
				}
				$res_str .= qq~</tr>~;
				$di_roll = $dic_roll - 1;
				if($b<$di_roll) {
					($dic_tot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicescore[$i]);
				}
			}
			$i--;
			$res_str .= qq~</table>~;

		if (!${$uid.$thisuser}{'password'}) { &LoadUser($thisuser); }
		$x = 0;
		$allow_roll = 0;
		$view_grp = "";

		$memberinform = $memberunfo{$thisuser};
		foreach $element (@dcgrp_allow) {
			chomp $element;
			if ($iamadmin || $iamgmod) { $allow_roll = 1; }
			if ($element eq $memberinform) { $allow_roll = 1; $view_grp .= qq~$dcgrp_view[$x]~; }
			$memberaddgroup{$thisuser} =~ s/\, /\,/g;
			foreach $memberaddgroups (split(/\,/, $memberaddgroup{$thisuser})) {
				chomp $memberaddgroups;
				if ($element eq $memberaddgroups) { $allow_roll = 1; $view_grp .= qq~$dcgrp_view[$x]~; }
			}
			$x++;
		}

		if($allow_roll) {
			$yymain .= qq~
			<tr>
			~;
				if($dice_sort == 1 || $dice_sort == 2) { 
			$yymain .= qq~
				<td class="windowbg" align="center" valign="middle">$z</td>
			~;
				}
			$yymain .= qq~
				<td class="windowbg2" align="left" valign="middle">${$uid.$thisuser}{'realname'}</td>
				<td class="windowbg2" align="left" valign="middle">$view_grp</td>
				<td class="windowbg" align="center" valign="middle">$dummy11</td>
				<td class="windowbg" align="center" valign="middle">$dummy12</td>
				<td class="windowbg2" align="left" valign="middle">$res_str</td>
				<td class="windowbg" align="center" valign="middle"><b>$dic_tot</b></td>
			</tr>
			~;
			$z++;
		}
	}
	$yymain .= qq~
	<tr>
		<td colspan="$tb_sp" class="catbg" align="center" valign="middle">&nbsp;</td>
	</tr>
	</table>
	~;
}

$yytitle = "$dicetxt{'1'}";
&template;
exit;

}


sub Dice {
if( $iamguest ) { &fatal_error($dicetxt{'41'}); }
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$dicehit{$key} = $value;
}


	$dice_total = 0;
	my($dice_str, $dice_sel, $dice_value);
	$the_round = $dicehit{'round'};
	if($the_round > 1) {
		for($i=1;$i<=10;$i++) {	$dice_stay[$i] = ""; }
		if($dicehit{'dice_sel1'}) { $dice_stay[1] = qq~ checked="checked"~; }
		$dval[1] = $dicehit{'dice_val1'};
		if($dicehit{'dice_sel2'}) { $dice_stay[2] = qq~ checked="checked"~; }
		$dval[2] = $dicehit{'dice_val2'};
		if($dicehit{'dice_sel3'}) { $dice_stay[3] = qq~ checked="checked"~; }
		$dval[3] = $dicehit{'dice_val3'};
		if($dicehit{'dice_sel4'}) { $dice_stay[4] = qq~ checked="checked"~; }
		$dval[4] = $dicehit{'dice_val4'};
		if($dicehit{'dice_sel5'}) { $dice_stay[5] = qq~ checked="checked"~; }
		$dval[5] = $dicehit{'dice_val5'};
		if($dicehit{'dice_sel6'}) { $dice_stay[6] = qq~ checked="checked"~; }
		$dval[6] = $dicehit{'dice_val6'};
		if($dicehit{'dice_sel7'}) { $dice_stay[7] = qq~ checked="checked"~; }
		$dval[7] = $dicehit{'dice_val7'};
		if($dicehit{'dice_sel8'}) { $dice_stay[8] = qq~ checked="checked"~; }
		$dval[8] = $dicehit{'dice_val8'};
		if($dicehit{'dice_sel9'}) { $dice_stay[9] = qq~ checked="checked"~; }
		$dval[9] = $dicehit{'dice_val9'};
		if($dicehit{'dice_sel10'}) { $dice_stay[10] = qq~ checked="checked"~; }
		$dval[10] = $dicehit{'dice_val10'};
	}
	for($i=1;$i<=10;$i++) {
		$di_val[$i] = 0;
	}
	$sel_num = 0;
	for($i=1;$i<=$dice_hits;$i++) {
		if($dice_stay[$i] ne ' checked="checked"') {
			$z = int( rand($dice_sides) );
			$z++;
		}
		else {
			$z = $dval[$i];
			$sel_num++;
		}
		$di_val[$i] = $z;
		if($dice_sides < 7) {
			$dice_str .= qq~<td><img src="$modimgurl/dice/tern$z.gif" width="31" height="31" alt="" border="0" /></td>~;
		}
		else {
			$dice_str .= qq~<td background="$modimgurl/dice/tern0.gif" width="31" height="31" align="center" valign="middle"><font size="2" color="#000000"><b>$z</b></font></td>~;
		}
		if($dice_allowstay) {
			$dice_sel .= qq~<td align="center"><input type="checkbox" name="dice_stay$i"$dice_stay[$i] /></td>~;
		}
		else {
			$dice_sel .= qq~<input type="hidden" name="dice_stay$i" value="" />~;
		}
		$dice_value .= qq~<input type="hidden" name="diceval$i" value="$z" />~;
		$dice_total = $dice_total + $z;
	}

	if($the_round == 1 || $dice_allowstay) {
		fopen(FILE, ">$vardir/$username.dice", 1);
		print FILE "$dice_total|$username|$dice_total|$di_val[1]|$di_val[2]|$di_val[3]|$di_val[4]|$di_val[5]|$di_val[6]|$di_val[7]|$di_val[8]|$di_val[9]|$di_val[10]|$dice_hits|$dice_sides|$dice_rolls|$dice_total\n";
		fclose(FILE);
	}
	else {
		fopen(FILE, "$vardir/$username.dice");
		@dicscore = <FILE>;
		$dicrol = @dicscore;
		fclose(FILE);
		chomp(@dicscore);

		for($i=0;$i<$dicrol;$i++) {
			( $dic_tot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicscore[$i]);
			$dic_tot = $dic_tot + $dice_total;
			if($dice_total > $dic_high) { $dic_high = $dice_total }
			$dicscore[$i] = "";
			$dicscore[$i] .= qq($dic_tot|$thisuser|$thisscore|$dummy[1]|$dummy[2]|$dummy[3]|$dummy[4]|$dummy[5]|$dummy[6]|$dummy[7]|$dummy[8]|$dummy[9]|$dummy[10]|$dummy11|$dummy12|$dic_roll|$dic_high);
		}

		fopen(FILE, ">$vardir/$username.dice", 1);
		for($i=0;$i<$dicrol;$i++) {
			print FILE "$dicscore[$i]\n";
		}
		if($the_round <= $dice_rolls) {
			print FILE "$dic_tot|$username|$dice_total|$di_val[1]|$di_val[2]|$di_val[3]|$di_val[4]|$di_val[5]|$di_val[6]|$di_val[7]|$di_val[8]|$di_val[9]|$di_val[10]|$dice_hits|$dice_sides|$dice_rolls|$dic_high\n";
		}
		fclose(FILE);
	}

	$view_round = $the_round;
	if($sel_num == $dice_hits) { $the_round = $dice_rounds }
	$end_round = $the_round;
	$the_round++;

	if($username eq "Guest") { $show_name = $maintxt{'28'} }
	else {
		if (!${$uid.$$username}{'password'}) { &LoadUser($username); }
		$show_name = ${$uid.$username}{'realname'};
	}

	$yymain .= qq~
	<table width="400" border="0" cellspacing="1" cellpadding="2" align="center">
	<tr>
	<td align="right" valign="middle">
	<span class="small"><a href="$scripturl?num=$diceset" class="imgwindowbg"><img src="$imagesdir/board.gif" alt="" border="0" align="absmiddle" /> $dicetxt{'26'}</a></span>
	</td>
	</tr>
	</table>
	<table width="400" border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
	<td class="titlebg" align="left" valign="middle">
	$dice_gif<span class="text1"><b> $dicetxt{'1'}</b> - $trdname - $show_name</span>
	</td>
	</tr>
	<tr>
	<td class="catbg" align="left" valign="middle">
	$dice_sides $dicetxt{'16'} - $dicetxt{'4'} $view_round $dicetxt{'9'} $dice_rounds
	</td>
	</tr>
	<form method="post" action="$scripturl?action=dicestart;round=$the_round;dsetup=$diceset" name="startdice">
		<input type="hidden" name="username" value="$username" />
		$dice_value
	<tr>
	<td align="center" class="windowbg">
	<table border="0" cellspacing="0" cellpadding="0" align="center">
	<tr>
		$dice_str
	</tr>
	~;
	if($end_round < $dice_rounds && $dice_allowstay) {
		$yymain .= qq~
		<tr>
			$dice_sel
		</tr>
		~;
	}
	$yymain .= qq~
	</table>
	</td>
	</tr>
	<tr>
	<td class="catbg" align="left" valign="middle">
	<table width="100%" border="0" cellspacing="0" cellpadding="0" align="left">
	<tr>
	<td>
	<table border="0" cellspacing="0" cellpadding="0" align="left">
	<tr>
	~;
	if($end_round < $dice_rounds) {
		$yymain .= qq~
		<td align="left" valign="middle">
			<input type="submit" value="$dicetxt{'4'} $the_round" style="width: 70px; font-size: 9" />
		</td>
		~;
	}
	$yymain .= qq~
	</form>
	~;
	if($iamgmod || $iamadmin) {
		$yymain .= qq~
		<form method="post" action="$scripturl?board=$theboard;action=dicesetup;dsetup=$diceset">
		<td align="left" valign="middle">
			<input type="submit" value="$dicetxt{'5'}" style="width: 70px; font-size: 9" />
		</td>
		</form>
		~;
	}
	$yymain .= qq~
	<td align="left" valign="middle">
		&nbsp;
	</td>
	</tr>
	</table>
	</td>
	<td align="right" valign="middle">
		<font size="2"><b>$dicetxt{'3'}: $dice_total</b></font>
	</td>
	</tr>
	</table>
	</td>
	</tr>
	</table>
	~;

	if($end_round == $dice_rounds) {

		if($username ne "Guest") {

			$allow_roll = 0;

			$memberinform = $memberunfo{$username};
			foreach $element (@dcgrp_allow) {
				chomp $element;
				if ($iamadmin || $iamgmod) { $allow_roll = 1; }
				if ($element eq $memberinform) { $allow_roll = 1; }
				$memberaddgroup{$username} =~ s/\, /\,/g;
				foreach $memberaddgroups (split(/\,/, $memberaddgroup{$username})) {
					chomp $memberaddgroups;
					if ($element eq $memberaddgroups) { $allow_roll = 1; last; }
				}
				if ($allow_roll == 1) { last; }
				$x++;
			}

			if($allow_roll) {
				fopen(FILE, "$vardir/$username.dice");
				@dicscore = <FILE>;
				fclose(FILE);
				chomp(@dicscore);
				if(!-e ("$vardir/$scorelist.dice")) {
					fopen(FILE, ">$vardir/$scorelist.dice", 1);
					for($z=0;$z<$dice_rolls;$z++) {
						print FILE "$dicscore[$z]\n";
					}
					fclose(FILE);
				}
				else {
					fopen(FILE, "$vardir/$scorelist.dice");
					@dicescores = <FILE>;
					$players = @dicescores;
					fclose(FILE);
					chomp(@dicescores);
					$new_player = 1;
					fopen(FILE, ">$vardir/$scorelist.dice", 1);
					for($i=0;$i<$players;$i++) { 
						print FILE "$dicescores[$i]\n";
					}
					for($z=0;$z<$dice_rolls;$z++) {
						print FILE "$dicscore[$z]\n";
					}
					fclose(FILE);
				}
			}
		}

		unlink("$vardir/$username.dice");

		if(-e ("$vardir/$scorelist.dice") && $dcgrp_allow[0] ne "") {
			fopen(FILE, "$vardir/$scorelist.dice");
			@dicescorer = <FILE>;
			$player = @dicescorer;
			fclose(FILE);
			chomp(@dicescorer);
			&PlayerSort;
			$show_grp = "";
			for($i=0;$i<$grp_num;$i++) {
				$show_grp .= qq~ - $dcgrp_view[$i]~;
			}
			$show_grp =~ s/\_/ /g;
			$yymain .= qq~
			<br /><br />
			<table border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
			<tr><td colspan="$tb_sp" class="titlebg" valign="middle">
			<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
			<tr>
			<td class="titlebg" valign="middle">
			$dice_gif<span class="text1"><b> $dicetxt{'10'} - $trdname</b></span>
			</td>
			~;
			if($iamgmod || $iamadmin) {
			$yymain .= qq~
			<form method="post" action="$scripturl?action=dicereset;dsetup=$diceset">
			<td class="titlebg" align="right" valign="middle">
				<input type="submit" value="$dicetxt{'11'}" style="font-size: 9" />
			</td>
			</form>
			~;
			}
			$yymain .= qq~
			</tr>
			</table>
			</td>
			</tr>
			<tr><td colspan="$tb_sp" class="windowbg" align="left" valign="middle">
				<span class="small"><b> $dicetxt{'25'}</b>$show_grp</span>
			</td>
			</tr>
			<tr>
			~;
				if($dice_sort == 1 || $dice_sort == 2) { 
			$yymain .= qq~
				<td class="catbg" align="center" valign="middle">$dicetxt{'18'}</td>
			~;
				}
			$yymain .= qq~
				<td class="catbg" align="center" valign="middle">$dicetxt{'17'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'8'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'1'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'16'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'3'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'6'}</td>
			</tr>
			~;
			$z=1;
			for($i=0;$i<$player;$i++) {
				my($res_str);
				($thistot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicescore[$i]);
				$res_str .= qq~<table border="0" cellspacing="0" cellpadding="0" align="center">~;
					for($b=0;$b<$dic_roll;$b++) {
						$i++;
						$res_str .= qq~<tr>~;
						for($x=1;$x<=$dummy11;$x++) {
							$res_str .= qq~
							<td height="31" width="31" align="center" valign="middle" background="$modimgurl/dice/tern0.gif"><font size="2" color="#000000"><b>$dummy[$x]</b></font></td>
							~;
						}
						if(!$dice_allowstay) {
							$res_str .= qq~<td width="31" align="center" valign="middle"><font size="2"><b>$thisscore</b></font></td>~;
						}
						$res_str .= qq~</tr>~;
						$di_roll = $dic_roll - 1;
						if($b<$di_roll) {
							($thistot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicescore[$i]);
						}
					}
					$i--;
					$res_str .= qq~</table>~;

				if (!${$uid.$thisuser}{'password'}) { &LoadUser($thisuser); }
				$x = 0;
				$allow_roll = 0;
				$view_grp = "";

				$memberinform = $memberunfo{$thisuser};
				foreach $element (@dcgrp_allow) {
					chomp $element;
					if ($iamadmin || $iamgmod) { $allow_roll = 1; }
					if ($element eq $memberinform) { $allow_roll = 1; $view_grp .= qq~$dcgrp_view[$x]~; }
					$memberaddgroup{$thisuser} =~ s/\, /\,/g;
					foreach $memberaddgroups (split(/\,/, $memberaddgroup{$thisuser})) {
						chomp $memberaddgroups;
						if ($element eq $memberaddgroups) { $allow_roll = 1; $view_grp .= qq~$dcgrp_view[$x]~; }
					}
					$x++;
				}

				if($allow_roll) {
					$yymain .= qq~
					<tr>
					~;
						if($dice_sort == 1 || $dice_sort == 2) { 
					$yymain .= qq~
						<td class="windowbg" align="center" valign="middle">$z</td>
					~;
						}
					$yymain .= qq~
						<td class="windowbg2" align="left" valign="middle">${$uid.$thisuser}{'realname'}</td>
						<td class="windowbg2" align="left" valign="middle">$view_grp</td>
						<td class="windowbg" align="center" valign="middle">$dummy11</td>
						<td class="windowbg" align="center" valign="middle">$dummy12</td>
						<td class="windowbg2" align="left" valign="middle">$res_str</td>
						<td class="windowbg" align="center" valign="middle"><b>$thistot</b></td>
					</tr>
					~;
					$z++;
				}
			}
			$yymain .= qq~
			<tr>
				<td colspan="$tb_sp" class="catbg" align="center" valign="middle">&nbsp;</td>
			</tr>
			</table>
			~;
		}
	}
	else {
		if(-e ("$vardir/$scorelist.dice")) {
			fopen(FILE, "$vardir/$scorelist.dice");
			@dicescorer = <FILE>;
			$player = @dicescorer;
			fclose(FILE);
			chomp(@dicescorer);
			&PlayerSort;
			$show_grp = "";
			for($i=0;$i<$grp_num;$i++) {
				$show_grp .= qq~ - $dcgrp_view[$i]~;
			}
			$show_grp =~ s/\_/ /g;
			$yymain .= qq~
			<br /><br />
			<table border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
			<tr>
			<td colspan="$tb_sp" class="titlebg" valign="middle">
			<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
			<tr>
			<td class="titlebg" valign="middle">
			$dice_gif<span class="text1"><b> $dicetxt{'10'} - $trdname</b></span>
			</td>
			~;
			if($iamgmod || $iamadmin) {
			$yymain .= qq~
			<form method="post" action="$scripturl?action=dicereset;dsetup=$diceset">
			<td class="titlebg" align="right" valign="middle">
				<input type="submit" value="$dicetxt{'11'}" style="font-size: 9" />
			</td>
			</form>
			~;
			}
			$yymain .= qq~
			</tr>
			</table>
			</td>
			</tr>
			<tr><td colspan="$tb_sp" class="windowbg" align="left" valign="middle">
				<span class="small"><b> $dicetxt{'25'}</b>$show_grp</span>
			</td>
			</tr>
			<tr>
			~;
				if($dice_sort == 1 || $dice_sort == 2) { 
			$yymain .= qq~
				<td class="catbg" align="center" valign="middle">$dicetxt{'18'}</td>
			~;
				}
			$yymain .= qq~
				<td class="catbg" align="center" valign="middle">$dicetxt{'17'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'8'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'1'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'16'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'3'}</td>
				<td class="catbg" align="center" valign="middle">$dicetxt{'6'}</td>
			</tr>
			~;
			$z=1;
			for($i=0;$i<$player;$i++) {
				my($res_str);
				($thistot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicescore[$i]);
				$res_str .= qq~<table border="0" cellspacing="0" cellpadding="0" align="center">~;
					for($b=0;$b<$dic_roll;$b++) {
						$i++;
						$res_str .= qq~<tr>~;
						for($x=1;$x<=$dummy11;$x++) {
							$res_str .= qq~
							<td height="31" width="31" align="center" valign="middle" background="$modimgurl/dice/tern0.gif"><font size="2" color="#000000"><b>$dummy[$x]</b></font></td>
							~;
						}
						if(!$dice_allowstay) {
							$res_str .= qq~<td width="31" align="center" valign="middle"><font size="2"><b>$thisscore</b></font></td>~;
						}
						$res_str .= qq~</tr>~;
						$di_roll = $dic_roll - 1;
						if($b<$di_roll) {
							($thistot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dic_roll, $dic_high) = split(/\|/, $dicescore[$i]);
						}
					}
					$i--;
					$res_str .= qq~</table>~;
				if (!${$uid.$thisuser}{'password'}) { &LoadUser($thisuser); }
				$x = 0;
				$allow_roll = 0;
				$view_grp = "";

				$memberinform = $memberunfo{$thisuser};
				foreach $element (@dcgrp_allow) {
					chomp $element;
					if ($iamadmin || $iamgmod) { $allow_roll = 1; }
					if ($element eq $memberinform) { $allow_roll = 1; $view_grp .= qq~$dcgrp_view[$x]~; }
					$memberaddgroup{$thisuser} =~ s/\, /\,/g;
					foreach $memberaddgroups (split(/\,/, $memberaddgroup{$thisuser})) {
						chomp $memberaddgroups;
						if ($element eq $memberaddgroups) { $allow_roll = 1; $view_grp .= qq~$dcgrp_view[$x]~; }
					}
					$x++;
				}

				if($allow_roll) {
					$yymain .= qq~
					<tr>
					~;
						if($dice_sort == 1 || $dice_sort == 2) { 
					$yymain .= qq~
						<td class="windowbg" align="center" valign="middle">$z</td>
					~;
						}
					$yymain .= qq~
						<td class="windowbg2" align="left" valign="middle">${$uid.$thisuser}{'realname'}</td>
						<td class="windowbg2" align="left" valign="middle">$view_grp</td>
						<td class="windowbg" align="center" valign="middle">$dummy11</td>
						<td class="windowbg" align="center" valign="middle">$dummy12</td>
						<td class="windowbg2" align="left" valign="middle">$res_str</td>
						<td class="windowbg" align="center" valign="middle"><b>$thistot</b></td>
					</tr>
					~;
					$z++;
				}
			}
			$yymain .= qq~
			<tr>
				<td colspan="$tb_sp" class="catbg" align="center" valign="middle">&nbsp;</td>
			</tr>
			</table>
			~;
		}
	}


	$yytitle = "$dicetxt{'1'}";
	&template;
	exit;
}


sub Dicesetup {
	my($sdice_lock, $sdice_allowstay, $sadd_dice_viewmode, $sadd_dice_rolls);
	if($dice_lock) { $sdice_lock = qq~ checked="checked"~; }
	if($dice_allowstay) { $sdice_allowstay = qq~ checked="checked"~; }
	if($add_dice_viewmode) { $sadd_dice_viewmode = qq~ checked="checked"~; }

	fopen(FILE, "$vardir/$diceset.die");
	@dicesettings = <FILE>;
	fclose(FILE);
	chomp(@dicesettings);

	(@curdicegroups) = split(/\,/, $dicesettings[2]);

	my $groupselect;
	my $nopostselect;
	my $postselect;

	my $groupcnt = 0;
	$groupselect .= qq~\n<optgroup label="$dicetxt{'43'}">~;
	foreach $selGroup (sort { $a cmp $b } keys %Group) {
		unless($selGroup eq "Moderator") {
			($title, $dummy) = split(/\|/, $Group{$selGroup}, 2);
			$selected = "";
			foreach $cur (@curdicegroups) {
				chomp $cur;
				($curgrp, undef) = split(/\|/, $cur);
				if($selGroup eq $curgrp) { $selected = qq~ selected="selected"~; break; }
			}
			$groupselect .= qq~\n<option value="$selGroup|$title"$selected>$title</option>~;
			$groupcnt++;
		}
	}
	$groupselect .= qq~\n</optgroup>~;
	$nopostselect .= qq~\n<optgroup label="$dicetxt{'25'}">~;
	foreach $selNoPost (sort { $a <=> $b } keys %NoPost) {
		($title, $dummy) = split(/\|/, $NoPost{$selNoPost}, 2);
		$selected = "";
		foreach $cur (@curdicegroups) {
			chomp $cur;
			($curgrp, undef) = split(/\|/, $cur);
			if($selNoPost eq $curgrp) { $selected = qq~ selected="selected"~; break; }
		}
		$nopostselect .= qq~\n<option value="$selNoPost|$title"$selected>$title</option>~;
		$groupcnt++;
	}
	$nopostselect .= qq~\n</optgroup>~;
	$postselect .= qq~\n<optgroup label="$dicetxt{'40'}">~;
	foreach $selPost (sort { $b <=> $a } keys %Post) {
		($title, $dummy) = split(/\|/, $Post{$selPost}, 2);
		$selected = "";
		foreach $cur (@curdicegroups) {
			chomp $cur;
			($curgrp, undef) = split(/\|/, $cur);
			if($title eq $curgrp) { $selected = qq~ selected="selected"~; break; }
		}
		$postselect .= qq~\n<option value="$title|$title"$selected>$title</option>~;
		$groupcnt++;
	}
	$postselect .= qq~\n</optgroup>~;

	if ($groupcnt > 12) { $groupcnt = 12; }
	my $mallowgroups = qq~
	<select name="mgr_allow" size="$groupcnt" multiple="multiple" style="width: 100%; font-size: 11px;">
	$groupselect
	$nopostselect
	$postselect
	</select>~;

	for($i=1;$i<=10;$i++) {
		$check[$i] = "";
		if($i == $dice_hits) { $check[$i] = qq~ selected="selected"~; }
	}

	for($i=1;$i<=4;$i++) {
		$sortck[$i] = "";
		if($i == $dice_sort) { $sortck[$i] = qq~ selected="selected"~; }
	}

	for($i=1;$i<=3;$i++) {
		$modeck[$i] = "";
		if($i == $dice_viewmode) { $modeck[$i] = qq~ selected="selected"~; }
	}

	$yymain .= qq~
	<form method="post" action="$scripturl?action=diceset;dsetup=$diceset;dback=$INFO{'dback'}">
	<table width="500" border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr><td colspan="2" class="titlebg" valign="middle">
	$dice_gif<span class="text1"><b> $dicetxt{'1'} $dicetxt{'5'}</b> - $trdname</span>
	</td></tr>
	<tr><td colspan="2" class="catbg" valign="middle">
	<b> $dicetxt{'37'}
	</td></tr>
	<tr>
	<td class="windowbg" width="50%" align="left" valign="top">
	$dicetxt{'25'}
	</td>
	<td class="windowbg" width="50%" align="left" valign="middle">
		$mallowgroups
	</td>
	</tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'36'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<select name="dicemode" style="font-size: 9px">
			<option value="1"$modeck[1]>$dicetxt{'37'}</option>
			<option value="2"$modeck[2]>$dicetxt{'38'}</option>
			<option value="3"$modeck[3]>$dicetxt{'39'}</option>
		</select>
	</td>
	</tr>
	<tr><td colspan="2" class="catbg" valign="middle">
	<b> $dicetxt{'38'}
	</td></tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'1'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<select name="dicenum" style="font-size: 9px">
			<option value="1"$check[1]>1</option>
			<option value="2"$check[2]>2</option>
			<option value="3"$check[3]>3</option>
			<option value="4"$check[4]>4</option>
			<option value="5"$check[5]>5</option>
			<option value="6"$check[6]>6</option>
			<option value="7"$check[7]>7</option>
			<option value="8"$check[8]>8</option>
			<option value="9"$check[9]>9</option>
			<option value="10"$check[10]>10</option>
		</select>
	</td>
	</tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'16'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<input style="font-size: 9px;" type="text" maxlength="3" name="dicesides" value="$dice_sides" size="2" />
	</td>
	</tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'7'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<input style="font-size: 9px;" type="text" maxlength="2" name="dicerounds" value="$dice_rounds" size="2" />
	</td>
	</tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'19'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<input type="checkbox" name="dice_allowstay" $sdice_allowstay />
	</td>
	</tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'22'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<select name="dicesort" style="font-size: 9px">
			<option value="1"$sortck[1]>$dicetxt{'21'}</option>
			<option value="2"$sortck[2]>$dicetxt{'20'}</option>
			<option value="3"$sortck[3]>$dicetxt{'17'}</option>
			<option value="4"$sortck[4]>$dicetxt{'8'}</option>
		</select>
	</td>
	</tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'13'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<input type="checkbox" name="dice_lock" $sdice_lock />
	</td>
	</tr>

	<tr><td colspan="2" class="catbg" valign="middle">
	<b> $dicetxt{'39'}
	</td></tr>
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'44'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<input type="checkbox" name="add_dice_viewmode" $sadd_dice_viewmode />
	</td>
	</tr>
<!--
	<tr>
	<td class="windowbg" align="left" valign="middle">
		$dicetxt{'47'}
	</td>
	<td class="windowbg" align="left" valign="middle">
		<input style="font-size: 9px;" type="text" maxlength="2" name="add_dice_rolls" value="$add_dice_rolls" size="2" />
	</td>
	</tr>
-->
	<tr><td colspan="2" class="catbg" align="center" valign="middle">
		<input type="submit" value="$dicetxt{'5'}" style="width: 120px; font-size: 9px" />
	</td></tr>
	</form>

	</table>
	~;
	$yytitle = "$dicetxt{'1'} $dicetxt{'5'}";
	&template;
	exit;
}


sub Dicereset {
if(-e ("$vardir/$scorelist.dice")) {
	unlink("$vardir/$scorelist.dice");
}
$yySetLocation = qq~$scripturl?action=dicestart;dsetup=$diceset~;
&redirectexit;
}


sub Diceremove {
if(-e ("$vardir/$diceset.die")) {
	unlink("$vardir/$diceset.die");
}
if(-e ("$vardir/$scorelist.dice")) {
	unlink("$vardir/$scorelist.dice");
}
$yySetLocation = qq~$scripturl?num=$diceset~;
&redirectexit;
}


sub Dicesetup2 {
my @onoff = qw/
	dice_allowstay dice_lock add_dice_viewmode/;

my $fi;
map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;

my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$dicesetup{$key} = $value;
}

if( $dicesetup{'dicesides'} =~ /\D/ ) { &fatal_error($maintxt{'337'}); }
if( $dicesetup{'dicerounds'} =~ /\D/ ) { &fatal_error($maintxt{'337'}); }
# if( $dicesetup{'add_dice_rolls'} =~ /\D/ ) { &fatal_error($maintxt{'337'}); }

$dicesetup{'mgr_allow'} =~ s~\A\s?,\s?~~;
$dicesetup{'mgr_allow'} =~ s~,\s~,~g;

$gr_allow = "";
if($dicesetup{'mgr_allow'} ne "") { $gr_allow = qq~$dicesetup{'mgr_allow'}~; }


fopen(FILE, ">$vardir/$diceset.die", 1);
print FILE "$dicesetup{'dicenum'}\n";
print FILE "$dicesetup{'dicerounds'}\n";
print FILE "$gr_allow\n";
print FILE "$dice_lock\n";
print FILE "$dicesetup{'dicesides'}\n";
print FILE "$dice_allowstay\n";
print FILE "$dicesetup{'dicesort'}\n";
print FILE "$dicesetup{'dicemode'}\n";
print FILE "$add_dice_viewmode\n";
# print FILE "$dicesetup{'add_dice_rolls'}\n";
fclose(FILE);

if($INFO{'dback'} eq "dadd") {
	$yySetLocation = qq~$scripturl?num=$diceset~;
}
elsif($INFO{'dback'} eq "droll") {
	$yySetLocation = qq~$scripturl?action=diceroll;num=$diceset~;
}
else {
	$yySetLocation = qq~$scripturl?action=dicestart;dsetup=$diceset~;
}
&redirectexit;
}


sub PlayerSort {

	@dicescore =();
	for($i=0;$i<$player;$i++) {
		($thistot, $thisuser, $thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dice_roll, $thishigh) = split(/\|/, $dicescorer[$i]);

		if($dice_sort == 1) { 
			$sort_param = 9999999 - $thishigh;
		}
		if($dice_sort == 2) { 
			$sort_param = 1;
		}
		if($dice_sort == 3) { 
			fopen(MEMBERFILEREAD,"$memberdir/$thisuser.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;
			$sort_param = $member[1];
		}
		if($dice_sort == 4) { 
			fopen(MEMBERFILEREAD,"$memberdir/$thisuser.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;
			$sort_param = $member[7];
		}

		$tmp_thistot = 9999999 - $thistot;
		$tmp_thisscore = 9999999 - $thisscore;
		$sort_dicescorer[$i] .= qq($sort_param|$tmp_thistot|$thisuser|$tmp_thisscore|$dummy[1]|$dummy[2]|$dummy[3]|$dummy[4]|$dummy[5]|$dummy[6]|$dummy[7]|$dummy[8]|$dummy[9]|$dummy[10]|$dummy11|$dummy12|$dice_roll|$thishigh);
	}
	@dicescores = sort{ lc $a cmp lc $b } (@sort_dicescorer);
	for($i=0;$i<$player;$i++) {
		($sort_param, $tmp_thistot, $thisuser, $tmp_thisscore, $dummy[1], $dummy[2], $dummy[3], $dummy[4], $dummy[5], $dummy[6], $dummy[7], $dummy[8], $dummy[9], $dummy[10], $dummy11, $dummy12, $dice_roll, $thishigh) = split(/\|/, $dicescores[$i]);
		$thistot = 9999999 - $tmp_thistot;
		$thisscore = 9999999 - $tmp_thisscore;
		$dicescore[$i] .= qq($thistot|$thisuser|$thisscore|$dummy[1]|$dummy[2]|$dummy[3]|$dummy[4]|$dummy[5]|$dummy[6]|$dummy[7]|$dummy[8]|$dummy[9]|$dummy[10]|$dummy11|$dummy12|$dice_roll|$thishigh);
	}
}


1;