#-------------------------------------------------------------------#
# DiceAddRoll.pl						    #
#-------------------------------------------------------------------#
# Dice 4 YaBB 2.1						    #
# Version 0.3 beta						    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2006 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: September 14, 2006					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#

require "$sourcedir/Post.pl";

sub AddRoll {
	if($username eq 'Guest') { &fatal_error($dicetxt{'41'}); }
	if( $currentboard eq '' ) { &fatal_error($maintxt{'1'}); }
	$threadid = $INFO{'num'};

	if(!-e ("$vardir/$threadid.die")) { &fatal_error($maintxt{'1'}); }

	fopen(FILE, "$vardir/$threadid.die");
	@dicesettings = <FILE>;
	fclose(FILE);
	chomp(@dicesettings);


	(@curdicgroups) = split(/\,/, $dicesettings[2]);

	$add_dice_viewmode = $dicesettings[8];
	$add_dice_rolls = $dicesettings[9];

	if (!${$uid.$username}{'password'}) { &LoadUser($username); }

	$x = 0;
	$grp_access = "";
	$view_grp = "";

	$memberinform = $memberunfo{$username};
	foreach $tmpelement (@curdicgroups) {
		chomp $tmpelement;
		($element, undef) = split(/\|/, $tmpelement);
		if ($iamadmin || $iamgmod) { $grp_access = 1; }
		if ($element eq $memberinform) { $grp_access = 1; }
		$memberaddgroup{$username} =~ s/\, /\,/g;
		foreach $memberaddgroups (split(/\,/, $memberaddgroup{$username})) {
			chomp $memberaddgroups;
			if ($element eq $memberaddgroups) { $grp_access = 1; last; }
		}
		if ($grp_access == 1) { last; }
		$x++;
	}

	if($iamadmin || $iamgmod || $grp_access) {

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
	if ($mstate =~ /l/i) { &fatal_error($dicetxt{'42'}); }
	$select = 'selected';

	$yymain .= qq~

	<table width="500" border="0" cellspacing="1" cellpadding="2" align="center">
	<tr>
		<td align="right" valign="middle" class="small">
			<a href="$scripturl?action=display;num=$threadid" class="imgwindowbg"><img src="$imagesdir/board.gif" alt="" border="0" align="absmiddle" /> $dicetxt{'26'}</a>
		</td>
	</tr>
	</table>

	<table width="500" border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
		<td colspan="4" class="titlebg" valign="middle">
			<img src="$modimgurl/dice/dice.gif" alt="" border="0" align="absmiddle" /><span class="text1"><b> $dicetxt{'1'}</b> - $msub - ${$uid.$username}{'realname'}</span>
		</td>
	</tr>
	<tr>
		<td class="catbg" align="center" valign="middle">
			$dicetxt{'28'}
		</td>
		<td class="catbg" align="center" valign="middle">
			$dicetxt{'31'}
		</td>
		<td class="catbg" align="center" valign="middle">
			$dicetxt{'29'}
		</td>
		<td class="catbg" align="center" valign="middle">
			$dicetxt{'45'}
		</td>
	</tr>
	<tr>
		<td class="windowbg" align="center" valign="middle">
			<form method="post" action="$scripturl?action=diceaddroll;num=$threadid">
			<input type="hidden" name="threadid" value="$threadid" />
			<input type="hidden" name="subject" value="$msub" />
			<input type="text" maxlength="3" name="quantity" value="1" size="4" />
		</td>
		<td class="windowbg" align="center" valign="middle">
			<select name="dicetype">
				<option value="2">d2</option>
				<option value="3">d3</option>
				<option value="4">d4</option>
				<option value="6">d6</option>
				<option value="8">d8</option>
				<option value="10">d10</option>
				<option value="12">d12</option>
				<option value="20" $select>d20</option>
				<option value="30">d30</option>
				<option value="100">d100</option>
			</select>
		</td>
		<td class="windowbg" align="center" valign="middle">
			<select name="modisign">
				<option value="+">+</option>
				<option value="-">-</option>
			</select>
			<input type="text" maxlength="2" name="modifier" value="0" size="2" />
		</td>

		<td class="windowbg" align="center" valign="middle">
			<input type="text" maxlength="3" name="add_target" value="0" size="4" />
		</td>

	</tr>
	<tr>
		<td colspan="4" class="catbg" align="center" valign="middle">
			<b>$dicetxt{'30'}</b>
		</td>
	</tr>
	<tr>
		<td colspan="4" class="windowbg" align="center" valign="middle">
			<input style="font-size: 9pt;" type="text" maxlength="100" name="description" value="" size="60" />
		</td>
	</tr>
	<tr>
		<td colspan="4" class="catbg" align="center" valign="middle">
			<input type="submit" value="$dicetxt{'2'}" style="width: 100px;" />
			</form>
		</td>
	</tr>
	</table><br />
	~;
	$theboard = $currentboard;
	if($iamgmod || $iamadmin) {
	$yymain .= qq~
	<table width="500" border="0" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
		<td colspan="3" class="catbg" align="center" valign="middle">
			<form method="post" action="$scripturl?board=$theboard;action=dicesetup;dsetup=$threadid;dback=droll">
			<input type="submit" value="$dicetxt{'5'}" style="width: 100px;" />
			</form>
		</td>
	</tr>
	</table>
	~;
	}

	$yytitle = "$dicetxt{'1'} $dicetxt{'5'}";
	&template;
	exit;
	}
	else { &fatal_error($maintxt{'1'}); }
}

sub AddRoll2 {
	if($username eq 'Guest') { &fatal_error($dicetxt{'41'}); }
	my($email, $subject, $message, $ns, $threadid, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	&BoardTotals("load", $currentboard);

	$quantity = $FORM{'quantity'};
	$dicetype = $FORM{'dicetype'};
	$viewdietype = "d$dicetype";
	$modisign = $FORM{'modisign'};
	$modifier = $FORM{'modifier'};
	$target = $FORM{'add_target'};
	$description = $FORM{'description'};
	$threadid = $FORM{'threadid'};

	if( $threadid =~ /\D/ ) { &fatal_error($maintxt{'337'}); }
	if( $quantity =~ /\D/ ) { &fatal_error($maintxt{'337'}); }
	if( $modifier =~ /\D/ ) { &fatal_error($maintxt{'337'}); }
	if( $target =~ /\D/ ) { &fatal_error($maintxt{'337'}); }

	$name  = ${$uid.$username}{'realname'};
	$email = ${$uid.$username}{'email'};
	$subject = qq~$dicetxt{'1'} $dicetxt{'4'}~;
	$subject =~ s/[\r\n]//g;
	$doaddsubject = $subject;
 	$icon = "dice";
	$ns = "";

	if(!-e ("$vardir/$threadid.die")) { &fatal_error($maintxt{'1'}); }

	fopen(FILE, "$vardir/$threadid.die");
	@dicesettings = <FILE>;
	fclose(FILE);
	chomp(@dicesettings);

	$result = 0;
	$less_target = 0;
	$dn = 1;

	for($i=0;$i<$quantity;$i++) {
		$z = int( rand($dicetype) );
		$z++;
		if($dicesettings[8]) {
			$tmpresult = sprintf("%02d", $z);
			$dnum_message .= qq~\[td\]\[center\]\[size=11\]\[b\]$dn\[/b\]\[/size\]\[/center\]\[/td\]~;
			if($z < $target) {
				$dres_message .= qq~\[td\]\[right\]\[size=11\]\[color=red\]$tmpresult\[/color\]\[/size\]\[/right\]\[/td\]~;
			}
			else {
				$dres_message .= qq~\[td\]\[right\]\[size=11\]\[color=green\]$tmpresult\[/color\]\[/size\]\[/right\]\[/td\]~;
			}
			$dn++;
		}
		if($z < $target) { $less_target += $z; }
		$result += $z;
	}

	if($modifier == 0) { $viewdtype = qq~$quantity$viewdietype~; }
	else { $viewdtype = qq~$quantity$viewdietype$modisign$modifier~; }

	$message .= qq~\[table\]~;
	$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'31'}: \[/b\]\[/size\]\[/td\]\[td\]\[size=11\] $viewdtype\[/size\]\[/td\]\[/tr\]~;
	if($target > 0) {
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'45'}: \[/b\]\[/size\]\[/td\]\[td\]\[size=11\] $target\[/size\]\[/td\]\[/tr\]~;
	}
	if($description ne "") {
		&fatal_error($dicetxt{'34'}) unless($description !~ m~\A[\s_.,]+\Z~);
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'33'}: \[/b\]\[/size\]\[/td\]\[td\]\[size=11\] $description\[/size\]\[/td\]\[/tr\]~;
	}
	$message .= qq~\[/table\]\n~;

	if($dicesettings[8]) {
		$message .= qq~\[table\]~;
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'46'}:\[/b\]\[/size\]\[/td\]~;
		$message .= qq~$dnum_message~;
		$message .= qq~\[/tr\]~;
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'35'}:\[/b\]\[/size\]\[/td\]~;
		$message .= qq~$dres_message~;
		$message .= qq~\[/tr\]~;
		$message .= qq~\[/table\]\n~;
	}

	if($modisign eq '+') { $tresult = $result + $modifier }
	else {$tresult = $result - $modifier }

	if($less_target > 0) {
		$tresult -= $less_target;
	}

	$message .= qq~\[table\]~;
	if($modifier > 0 || $less_target > 0) {
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'4'} $dicetxt{'35'}:\[/b\]\[/size\]\[/td\]~;
		$message .= qq~\[td\]\[right\]\[size=11\] $result\[/size\]\[/right\]\[/td\]~;
		$message .= qq~\[/tr\]~;
	}
	if($modifier > 0) {
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$modisign $dicetxt{'29'}:\[/b\]\[/size\]\[/td\]~;
		$message .= qq~\[td\]\[right\]\[size=11\] $modifier\[/size\]\[/right\]\[/td\]~;
		$message .= qq~\[/tr\]~;
	}
	if($less_target > 0) {
		$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]- $dicetxt{'48'}:\[/b\]\[/size\]\[/td\]~;
		$message .= qq~\[td\]\[right\]\[size=11\] $less_target\[/size\]\[/right\]\[/td\]~;
		$message .= qq~\[/tr\]~;
	}
	$message .= qq~\[tr\]\[td\]\[size=11\]\[b\]$dicetxt{'35'}:\[/b\]\[/size\]\[/td\]~;
	$message .= qq~\[td\]\[right\]\[size=11\]$tresult\[/size\]\[/right\]\[/td\]~;
	$message .= qq~\[/tr\]~;
	$message .= qq~\[/table\]~;

	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($message);
	$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$message =~ s~\n~<br />~g;
	&CheckIcon;
	if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }

	&MessageTotals("load", $threadid);

	if ("${$threadid}{'board'}" ne "$currentboard") {
		unless (&AccessCheck(${$threadid}{'board'}, 2) eq "granted") { &fatal_error("$post_txt{'804'}"); }
		$currentboard = ${$threadid}{'board'};
	}

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $yyThreadLine);
	$mreplies = ${$threadid}{'replies'};
	if ($mstate =~ /l/i) { &fatal_error($post_txt{'90'}); }
	if ($currentboard eq $annboard && $mstate !~ /a/i) { $mstate = "0a"; }
	$mreplies++;
	fopen(BOARDFILE, "+<$boardsdir/$currentboard.txt", 1) || &write_error("211 $post_txt{'106'}: $post_txt{'23'} $currentboard.txt", 1);
	seek BOARDFILE, 0, 0;
	my @buffer = <BOARDFILE>;
	truncate BOARDFILE, 0;

	for ($i = 0; $i < @buffer; $i++) {
		if ($buffer[$i] =~ m~\A$mnum\|~o) { $buffer[$i] = ""; last; }
	}
	seek BOARDFILE, 0, 0;
	print BOARDFILE qq~$mnum|$msub|$mname|$memail|$date|$mreplies|$musername|$micon|$mstate\n~;
	print BOARDFILE @buffer;
	fclose(BOARDFILE);
	fopen(THREADFILE, ">>$datadir/$threadid.txt") || &write_error("212 $post_txt{'106'}: $post_txt{'23'} $threadid.txt", 1);
	print THREADFILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||\n~;
	fclose(THREADFILE);

	$tmpstate = $mstate || '0';
	${$threadid}{'board'}        = $currentboard;
	${$threadid}{'replies'}      = $mreplies;
	${$threadid}{'lastposter'}   = $iamguest ? qq~Guest-$name~ : $username;
	${$threadid}{'lastpostdate'} = "$date";
	${$threadid}{'threadstatus'} = "$tmpstate";

	&MessageTotals("update", $threadid);
	&ReplyNotify($threadid, $subject);

	if (!${$uid.$currentboard}{'zero'}) {
		${$uid.$username}{'postcount'}++;
		&UserAccount($username, "update", "lastpost");
		&UserAccount($username, "update", "lastonline");

		if (${$uid.$username}{'position'}) {
			$grp_after = qq~${$uid.$username}{'position'}~;
		} else {
			foreach $postamount (sort { $b <=> $a } keys %Post) {
				if (${$uid.$username}{'postcount'} > $postamount) {
					($title, undef) = split(/\|/, $Post{$postamount}, 2);
					$grp_after = $title;
					last;
				}
			}
		}
		&ManageMemberinfo("update", $username, '', '', $grp_after, ${$uid.$username}{'postcount'});
	} else {
		&UserAccount($username, "update", "lastpost");
		&UserAccount($username, "update", "lastonline");
	}

	$thread = $threadid;

	$start     = 0;
	$pageindex = int($mreplies / $maxmessagedisplay);
	$start     = $pageindex * $maxmessagedisplay;

	&dumplog($currentboard, $date);

	${$uid.$currentboard}{'messagecount'}++;
	unless ($FORM{'threadid'}) {
		${$uid.$currentboard}{'threadcount'}++;
		++$threadcount;
	}
	${$uid.$currentboard}{'lastposttime'} = $date;
	${$uid.$currentboard}{'lastposter'}   = $username;
	${$uid.$currentboard}{'lastpostid'}   = $thread;
	${$uid.$currentboard}{'lastreply'}    = $mreplies;
	${$uid.$currentboard}{'lastsubject'}  = $doaddsubject;
	${$uid.$currentboard}{'lasticon'}     = $icon;

	&BoardTotals("update", $currentboard);

	if(!$iamguest) { &Recent_Write("incr", $thread, $username); }

	if ($currentboard eq $annboard) {
		$yySetLocation = qq~$scripturl?virboard=$currentboard;num=$thread/$start#$mreplies~;
	} else {
		$yySetLocation = qq~$scripturl?num=$thread/$start#$mreplies~;
	}

	$start = $mreplies;
	&redirectexit;
}

1;